#include "stm32f10x.h"
#include "stdio.h"
#include "lcd4bit.h"

__IO int a=0,b;
int in_freq;
char s[16];
int humidity;

void delay_ms( uint16_t mSecs ) 
{
  uint16_t start = TIM3->CNT;
  /* mse 16 bit count wrap around */
  while((uint16_t)(TIM3->CNT - start) <= mSecs);
}
/***************** Timing ovf function********************* */
void TIM2_IRQHandler(void)
{
a++;
       if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET)
	   {
       TIM_ClearITPendingBit(TIM2, TIM_IT_Update);//reset timer flag
	   }

}
void GPIO_Configuration(void);
void NVIC_Configuration(void);
void TIM_Configuration(void);
void delay_init( void );
int main(void)
{
GPIO_Configuration();
NVIC_Configuration();
TIM_Configuration();
TIM2->CNT=0x00;
lcd_init();
delay_init();
	
while(1)
 {
  TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE);
  delay_ms(1000);
  TIM_ITConfig(TIM2, TIM_IT_Update, DISABLE);
	   b=TIM2->CNT;
 	   in_freq=(a*1000+b);
	   sprintf(s,"Freq:%d    ",in_freq);
       set_cursor(1,1);
       lcd_putsf(s);

	   humidity=(-0.07874)*(in_freq-7351);
	   sprintf(s,"Hum:%d   ",humidity);
       set_cursor(2,1);
       lcd_putsf(s);	    

	   a=0;
	   TIM2->CNT=0x00;
  }
}
/********************** GPIO configuration*********************************/
void GPIO_Configuration(void)
{
GPIO_InitTypeDef GPIO_InitStructure;

RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);


GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING; 
GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 	
GPIO_Init(GPIOA, &GPIO_InitStructure);
}
/**************timer config*****************/
void TIM_Configuration(void)
{
TIM_TimeBaseInitTypeDef  TIM_BaseInitStructure;
RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);
TIM_BaseInitStructure.TIM_Period =1000; // 
TIM_BaseInitStructure.TIM_Prescaler =0; // 
TIM_BaseInitStructure.TIM_ClockDivision =0;
TIM_BaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
TIM_TimeBaseInit(TIM2, &TIM_BaseInitStructure);

/* TIM IT enable: for overflow  */
TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE);

TIM_TIxExternalClockConfig(TIM2, TIM_TIxExternalCLK1Source_TI1, TIM_ICPolarity_Rising, 0);
/* TIM2 enable  */
TIM_Cmd(TIM2, ENABLE);
}

//**************config NVIC************************
void NVIC_Configuration(void)
{
NVIC_InitTypeDef NVIC_InitStructure;	
NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x01;
NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x01;
NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
NVIC_Init(&NVIC_InitStructure);
}

void delay_init( void ) 
{

  TIM_TimeBaseInitTypeDef  TIM_BaseInitStructure;
    
  /* Enable timer clock  - use TIMER3 */
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);
  TIM_BaseInitStructure.TIM_Period =UINT16_MAX; // 
  TIM_BaseInitStructure.TIM_Prescaler =36000-1; // 
  TIM_BaseInitStructure.TIM_ClockDivision =0;
  TIM_BaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up;
  TIM_TimeBaseInit(TIM3, &TIM_BaseInitStructure);

    
 /* Enable counter */
  TIM_Cmd(TIM3, ENABLE);
}	
