#ifndef __USART_H
#define __USART_H
#include "stdio.h"	  
#ifdef __GNUC__								 
  #define PUTCHAR_PROTOTYPE int __io_putchar(int ch)
#else
  #define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#endif 

PUTCHAR_PROTOTYPE
{										 
	USART_SendData(USART1,(u8)ch);
  	while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET); 
  	return ch;
}  	
	   
void NVIC_Configuration(void)
{
	NVIC_InitTypeDef NVIC_InitStructure;	 
	#ifdef  VECT_TAB_RAM  									   
		NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0); 
	#else   							 
		NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);   
	#endif    										     
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);	   
	//NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQChannel;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);	 								 
} 

u8 time_set[7];	
u8 rebuffer[14]; 
u8 recount=0;      
void USART1_IRQHandler(void)
{
	u8 res;	    
	if(USART1->SR&(1<<5))
	{	 
		res=USART1->DR;   			   
		if(recount<14&&res>47&&res<58)
		{
			rebuffer[recount]=res-'0';
			recount++;
		}  											     
	}  
} 										 

void uart_init()
{  	 
	RCC->APB2ENR|=1<<2;   
	RCC->APB2ENR|=1<<14;  
	GPIOA->CRH=0X444444B4;
		  
	RCC->APB2RSTR|=1<<14;   
	RCC->APB2RSTR&=~(1<<14); 

   	RCC->APB2ENR|=1<<9;	  //TX
	RCC->APB2ENR|=1<<10;  //RX  

 	USART1->BRR=0X1D4C;    //9600 
	USART1->CR1|=0X200C;   

	USART1->CR1|=1<<8;    
	USART1->CR1|=1<<5;    
	NVIC_Configuration(); 	
}
#endif	   
















